"""
CORRECTION des exercices 4, 5 et 6 sur la récursivité
"""
# ========================================================== Exercice 4 suite Un
def ex4_suite_Un ( n:int, Un:int=0, U0:int=4, recurs:bool=False )->float:
    try :
        if n==0 :
            print(U0, ", ", end="") # premier terme de la suite
            return U0
        if n < 0 : raise ValueError()
        Un = (ex4_suite_Un ( n-1, Un, recurs=True ) / ((n-1) + 1)) + 4
        if Un != None :
            if recurs :
                print(" {:5.3f} ,".format(Un), end="") # termes intermédiaires de la suite
            else :
                print(" {:5.3f}".format(Un) ) # Dernier terme
            return Un
        else :
            return None
    except ValueError :
        print("ex4_suite_Un ( n ) : n doit être un entier positif ou nul !")
        return None
    
# ===================================================== exercice 5 : Syracuse
def syracuse ( n : int ) -> list :
    """
    That is a function wich return the Syracuse suite.
    In : n (natural integer : 0 < n)
    Out : [ Un ] Syracuse suite
    : Exemple :
    >>> python recursif_syracuse.py 10 
    [10, 5, 16, 8, 4, 2, 1]
    
    >>> python recursif_syracuse 9
    [9, 28, 14, 7, 22, 11, 34, 17, 52, 26, 13, 40, 20, 10, 5, 16, 8, 4, 2, 1]
    
    """
    Un = [n]
    if n == 1 : # End condition [ n = 1 ]
        return [1]
    elif n%2 : # else n is an odd number then calculate 3*n + 1
        Un = Un + syracuse(3*n+1)
    else : # If n is an even number n%2 = 0 then calculate n // 2
        Un = Un + syracuse( n//2 )
    return Un


# ====================================================== Exercice 6 - 1 progression
def progression_verif ( Un:float, n:int ) -> list :
    """
    Un+1 = 1.5 * Un + 2
    """

    # condition de fin
    if n == 0 :
        return [Un]
    return [Un] + progression_verif ( 1.5*Un+2, n-1 )

# ====================================================== Exercice 6 - 2 inverse vers U0
def progression_inverse ( Un:float, n:int=0 )-> list :
    """
    Un = (Un+1 - 2) / 1.5
    """
    if Un<2 : # Si la Un<2 alors on a atteint la valeur U0 puisque U1 = 1.5xU0 + 2
        return [ (Un, n) ]
    return [ (Un, n) ] + progression_inverse ( (Un-2)/1.5, n+1 )

# ====================================================== main : Test des solutions
if __name__ == '__main__' :
    n = 6
    print("Suite Un exercice 4 pour n=", n )
    ex4_suite_Un ( n )
    print("\n")
    print("Suite de Syracuse pour n=96 ... ")
    print( syracuse ( 96 ) )
    
    print("\n")
    print("Exercice 6 - 1 : créer une suite de vérification (  ... ")
    print("U0=1,  n=4 -> ", progression_verif ( Un=1, n=5 ) )

    print("\n")
    print("Exercice 6 - 2 : retrouver U0 et le nombre de termes n ... ")
    liste = progression_inverse( 33.96875 )
    print ( liste )
    # print ( " Valeur initiale : ", U0, "  / Nombre de jours : ", n)

